#include "Expense.h"

Expense* Expense::clone() const
{
    Expense* newExpense = new Expense();
    newExpense->setDate( date() );
    newExpense->setDescription( description() );
    newExpense->setCurrency( currency() );
    newExpense->setCategory( category() );
    newExpense->setAmount( amount() );
    
    return newExpense;
}


void Expense::copyValues( Expense* target ) const
{
    target->setDate( date() );
    target->setDescription( description() );
    target->setCurrency( currency() );
    target->setCategory( category() );
    target->setAmount( amount() );
}


void Expense::setDate( const QDate& date )
{
    _date = date;
}


QString Expense::dateString() const
{
    return _date.toString( Qt::LocalDate );
}


QDate Expense::date() const
{
    return _date;
}


void Expense::setDescription( const QString& description )
{
    _description = description;
}


QString Expense::description() const
{
    return _description;
}


void Expense::setCategory( const QString& category )
{
    _category = category;
}


QString Expense::category() const
{
    return _category;
}


void Expense::setCurrency( const QString& currency )
{
    _currency = currency;
}


QString Expense::currency() const
{
    return _currency;
}


void Expense::setAmount( double amount )
{
    _amount = amount;
}


QString Expense::amountString() const
{
    return QString::number( _amount, 'f', 2 );
}


double Expense::amount() const
{
    return _amount;
}

   

