/* GraphAll.h

   Author:  Timothy Rolfe

   Extend Graph.h to allow the exponential algorithms that examine
   ALL paths
*/
#ifndef GRAPHALL_H
#define GRAPHALL_H

#include <iostream.h>
#include <fstream.h>
#include "Graph.h"

/********************* CGraphAll Class Declaration *********************/

class CGraphAll : public CGraph
{
   public:
      CGraphAll(void)   // Actually, we don't need this at all!
      : CGraph()  {}

//    Traversal routines

//    Each of the following uses a private member function
      void allPaths   ( char* Start, char* End );
      void simplePaths( char* Start, char* End );
      void Hamiltonian( char* Start );
      void travelSales( char* Start );
//    REPORT the smallest sequence discovered
      void minSeq ( ostream &O )
      {  minSeq ( -1, O ) ;  }

//    List the edges in the resulting spanning tree
//    Over-ride the default to adjust for marking the edges
//    by setting their weights negative.
      void edgeList   ( ostream & );

   private:

//    Called by the respective public member functions
      void allPaths   ( int Source, int Dest );
      void simplePaths( int Source, int Dest );
      void Hamiltonian( int Source, int Dest );
      void travelSales( int Source, int Dest );
//    Options:  -1 to report, +1 to initialize, 0 to update
      void minSeq ( int Opt, ostream &O = cout );

//    Counter for travelSales --- number of circuits checked in
//    the generalized traveling salesman problem (allowing more
//    that one visit to a vertex).
      long m_PathsChecked;
};

#endif
