/////////////////////////////////////////////////////////////////////////////
// SISNET USer Aplication Software (UAS) Example                           //
// (c) ESA 2001 by Felix Toran-Marti, Javier Ventura-Traveset and          //
//     Juan Carlos de Mateo.                                               //
//                                                                         //
// For any question or suggestion, please contact the authors at:          //
//                                                                         //
// Felix Toran-Marti (ftoran@esa.int ; ftoran@aimme.es)                    //
// Javier Ventura-Traveset (jventura@esa.int)                              //
// J.C. de Mateo (jdemateo@estec.esa.nl)                                   //
//                                                                         //
//                                                                         //
// This application demonstrates how to build a basic SISNET UAS.          //
// The source code can be used as a baseline for integrating               //
// SISNET applications on it. In fact, this application basically          //
// monitors the EGNOS messages received from the SISNET Data Server.       //
// Only one processing block has been applied, which mission is to         //
// analyse the received message types.                                     //
/////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ScktComp.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include "SINCA.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// Composants grs par l'EDI
        TClientSocket *Client;
        TStaticText *EGNOSMsg;
        TLabel *Label1;
        TButton *BtnConnect;
        TButton *BtnDisconnect;
        TButton *BtnClose;
        TImage *Image1;
        TImage *Image2;
        TBevel *Bevel1;
        TLabel *Label3;
        TLabel *Label2;
        TLabel *Label4;
        TEdit *Port;
        TEdit *DataServerIP;
        TStatusBar *Status;
        TTimer *Timer;
        TLabel *Label5;
        TLabel *Label6;
        TStaticText *Week;
        TStaticText *Time;
        TSINCA *SINCA;
        TBevel *Bevel2;
        TBevel *Bevel3;
        TBevel *Bevel4;
        TBevel *Bevel5;
        TBevel *Bevel6;
        TLabel *Label8;
        TStaticText *MsgType;
        TBevel *Bevel7;
        void __fastcall BtnCloseClick(TObject *Sender);
        void __fastcall BtnConnectClick(TObject *Sender);
        void __fastcall ClientError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall ClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientConnecting(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientLookup(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall TimerTimer(TObject *Sender);
        void __fastcall BtnDisconnectClick(TObject *Sender);

private:	// Dclarations utilisateur

//Extracts a field from a given DS2DC command.
//The arguments indicate the command to analyse and the order
//number of the field to extract.
AnsiString __fastcall ExtractDS2DCField(AnsiString,int);


//Resets the command buttons to the original state
void __fastcall ResetBtns();


//Returns the message type of an EGNOS message
int __fastcall GetMT(AnsiString);


public:		// Dclarations utilisateur
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
