// Wave.cpp

#include "stdafx.h"
#include "Wave.h"

namespace DDJCColumnWave	{

Wave::Wave(int b, int rate, int nc, int samples)
{
	bps = b;			// bits per sample (8 or 16)
	samplerate = rate;	// samples per second (11025, 22050, 44100, etc.)
	nch = nc;			// number of channels (1 or 2)
	buflen = (samples * nch * (bps / 8));
	// derived ctor might throw something
	samplebuf1 = std::auto_ptr<char>(new char[buflen*2]);
	samplebuf2 = std::auto_ptr<char>(new char[buflen*2]);
	// initialize first WAVEHDR struct
	hdr1.lpData = 0;
	hdr1.dwBufferLength = buflen;
	hdr1.dwBytesRecorded = 0;
	hdr1.dwUser = 0;
	hdr1.dwFlags = 0;
	hdr1.dwLoops = 0;
	hdr1.lpNext = 0;
	hdr1.reserved = 0;
	// initialize second WAVEHDR struct
	hdr2 = hdr1;
	hdr1.lpData = samplebuf1.get();
	hdr2.lpData = samplebuf2.get();
	// initialize WAVEFORMATEX struct
	int blkalign = ((nch * bps) / 8);
	wfmt.wFormatTag		 = WAVE_FORMAT_PCM;
	wfmt.nChannels		 = nch;
	wfmt.nSamplesPerSec	 = samplerate;
	wfmt.nAvgBytesPerSec = rate * blkalign;
	wfmt.nBlockAlign	 = blkalign;
	wfmt.wBitsPerSample	 = bps;
	wfmt.cbSize			 = 0;
}

} // namespace DDJCColumnWave
