// Wave.h
#ifndef WAVES_H
#define WAVES_H

#include <memory>

namespace DDJCColumnWave	{

class Wave	{
protected:
	int bps;					// bits per sample (8,16)
	int samplerate;				// samples per second
	int nch;					// number of channels (1,2)
	std::auto_ptr<char> samplebuf1;
	std::auto_ptr<char> samplebuf2;
	WAVEHDR hdr1;
	WAVEHDR hdr2;
	int buflen;
	WAVEFORMATEX wfmt;
	Wave(int b, int rate, int nc, int samples);
	virtual ~Wave() { }
};

} // namespace DDJCColumnWave

#endif // WAVES_H